package de.intevation.flys.artifacts.states.minfo;

import org.w3c.dom.Element;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;
import de.intevation.artifacts.CallMeta;
import de.intevation.artifacts.common.utils.XMLUtils;
import de.intevation.flys.artifacts.resources.Resources;
import de.intevation.flys.artifacts.states.DefaultState;

public class CharDiameter extends DefaultState {

    public static final String UI_PROVIDER = "minfo.bed.char_diameter";

    private static final String CHAR_DIAMETER_MIN  = "calc.bed.dmin";
    private static final String CHAR_DIAMETER_MAX  = "calc.bed.dmax";
    private static final String CHAR_DIAMETER_MID  = "calc.bed.dmid";
    private static final String CHAR_DIAMETER_90  = "calc.bed.d90";
    private static final String CHAR_DIAMETER_84  = "calc.bed.d84";
    private static final String CHAR_DIAMETER_80  = "calc.bed.d80";
    private static final String CHAR_DIAMETER_75  = "calc.bed.d75";
    private static final String CHAR_DIAMETER_70  = "calc.bed.d70";
    private static final String CHAR_DIAMETER_60  = "calc.bed.d60";
    private static final String CHAR_DIAMETER_50  = "calc.bed.d50";
    private static final String CHAR_DIAMETER_40  = "calc.bed.d40";
    private static final String CHAR_DIAMETER_30  = "calc.bed.d30";
    private static final String CHAR_DIAMETER_25  = "calc.bed.d25";
    private static final String CHAR_DIAMETER_20  = "calc.bed.d20";
    private static final String CHAR_DIAMETER_16  = "calc.bed.d16";
    private static final String CHAR_DIAMETER_10  = "calc.bed.d10";

    public static final String[] CHAR_DIAMETER = {
        CHAR_DIAMETER_10,
        CHAR_DIAMETER_16,
        CHAR_DIAMETER_20,
        CHAR_DIAMETER_25,
        CHAR_DIAMETER_30,
        CHAR_DIAMETER_40,
        CHAR_DIAMETER_50,
        CHAR_DIAMETER_60,
        CHAR_DIAMETER_70,
        CHAR_DIAMETER_75,
        CHAR_DIAMETER_80,
        CHAR_DIAMETER_84,
        CHAR_DIAMETER_90,
        CHAR_DIAMETER_MAX,
        CHAR_DIAMETER_MID,
        CHAR_DIAMETER_MIN
    };

    @Override
    public String getUIProvider() {
        return UI_PROVIDER;
    }

    @Override
    protected Element[] createItems(
        XMLUtils.ElementCreator cr,
        Artifact    artifact,
        String      name,
        CallContext context)
    {
        CallMeta meta   = context.getMeta();
        Element[] calcs = new Element[CHAR_DIAMETER.length];

        for (int i = 0; i < CHAR_DIAMETER.length; ++i) {
            String calc = CHAR_DIAMETER[i];
            calcs[i] = createItem(
                cr, new String[] {
                    Resources.getMsg(meta, calc, calc),
                    calc
                });
        }

        return calcs;
    }

}
